<template>
  <Transition name="fade">
  <div class="login-popup" v-if="open">
    <Transition appear name="fade-up">
    <div class="login-window" v-if="windowOpen">
      <span v-wave class="close-btn" @click="close">×</span>
      <div class="login-title">התחברות</div>
      <form class="login-form" ref="form" @submit.prevent="login">
        <input class="login-input ltr" type="text" name="email" id="email" placeholder="אימייל">
        <input class="login-input ltr" type="password" name="password" id="password" placeholder="סיסמה" autocomplete="off">
        <Transition name="grow"> 
        <easy-spinner type="circular" color="rgb(170, 170, 200)" v-if="loginStatus == 'loading'" />
        </Transition>
        <Transition name="grow"> 
        <div class="error" v-if="loginStatus == 'error'">פרטים שגויים!</div>
        </Transition>
        <Transition name="grow"> 
        <div class="success" v-if="loginStatus == 'success'"></div>
        </Transition>
        <input v-wave type="submit" class="btn login-btn" value="התחבר">
      </form>
    </div>
    </Transition>
  </div>
  </Transition>
</template>

<script>
import { logIn } from '../firebase.js'

export default {
  data() {
    return {
      open: false,
      windowOpen: false,
      loginStatus: '',
    }
  },
  methods: {
    loginPopup() {
      this.open = true
      this.windowOpen = true
      this.loginStatus = ''
      document.body.style.overflow = 'hidden'
    },
    login() {
      this.loginStatus = 'loading'
      let email = this.$refs.form.email.value
      let pass = this.$refs.form.password.value
      if (email && pass) {
        logIn(email, pass)
        .then(() => this.loginSuccess())
        .catch(()=> this.loginfailed())
      }
    },
    loginSuccess() {
      this.loginStatus = 'success'
      setTimeout(() => {
        this.close()
      }, 500);
    },
    loginfailed() {
      this.loginStatus = 'error'
    },
    close() {
      document.body.style.overflow = 'auto'
      this.error = false
      this.windowOpen = false
      Promise.resolve().then(()=> {
        this.open = false
      })
    }
  }
}
</script>

<style scoped>

.login-popup {
  position: fixed;
  z-index: 20;
  top: 0;
  right: 0;
  height: 100vh;
  width: 100vw;
  background-color: rgba(0, 0, 90, 0.5);
  display: flex;
  align-items: center;
  justify-content: center;
}

.login-window {
  max-width: 90%;
  padding: 1em 3em;
  overflow: auto;
  position: relative;
  font-size: 1.5em;
  background-color: #fff;
  border-radius: 1em;
  box-shadow: 0 0 1em rgba(0, 0, 90, 0.5);
  display: flex;
  flex-direction: column;
  align-items: center;
  justify-content: center;
}

.login-title {
  color: var(--blue);
  font-size: 2em;
  font-weight: bold;
  margin: .25em 0;
}

.login-form {
  display: flex;
  flex-direction: column;
  align-items: center;
  width: 20em;
  max-width: 100%;
  font-size: 1.5em;
}

.login-input {
  text-align: center;
  width: 100%;
  font-size: 1em;
  margin: .5em 0;
  border-radius: .25em;
  border: .1em solid var(--lightBlue);
}

.login-btn {
  border: none;
  font-size: 1em;
  height: 2em;
  display: flex;
  justify-content: center;
  align-items: center;
  cursor: pointer;
  width: fit-content;
  padding: .25em .5em;
  border-radius: .25em;
  margin: .25em;
  background-color: var(--lightBlue2);
  color: #fff;
}

.error {
  color: var(--lightRed2);
  height: 1.5em;
  font-weight: bold;
}

.success {
  height: 1.5em;
  width: 100%;
  background-image: url(../assets/done2.svg);
  background-size: contain;
  background-repeat: no-repeat;
  background-position: center;
}

</style>